LOWDOWN_ODT_NEW(3)

NAME
lowdown_odt_new - allocate a Markdown OpenDocument renderer

LIBRARY
liblowdown

SYNOPSIS
#include <sys/queue.h>
#include <stdio.h>
#include <lowdown.h>
void *
lowdown_odt_new(const struct lowdown_opts *opts);

DESCRIPTION
Allocates an OpenDocument renderer using opts->flags, or zero if opts is NULL. This field is documented in lowdown(3). The returned pointer may be used with multiple invocations of lowdown_odt_rndr(3) and must be freed with lowdown_odt_free(3).

The bits recognised in opts->oflags are LOWDOWN_ODT_SKIP_HTML and LOWDOWN_STANDALONE.

The opts->odt.sty field, if not NULL, overrides the default <office:font-face-decls>, <office:scripts>, and <office:styles> elements of the document styles.

RETURN VALUES
Returns a pointer to the renderer or NULL on memory failure. The returned pointer must be freed with lowdown_odt_free(3).

EXAMPLES
The following parses b of length bsz and outputs in “flat” OpenDocument format.

    struct lowdown_buf *out;
    struct lowdown_doc *doc;
    struct lowdown_node *n;
    void *rndr;
    if ((doc = lowdown_doc_new(NULL)) == NULL)
    	err(1, NULL);
    if ((n = lowdown_doc_parse(doc, NULL, b, bsz, NULL)) == NULL)
    	err(1, NULL);
    if ((out = lowdown_buf_new(256)) == NULL)
    	err(1, NULL);
    if ((rndr = lowdown_odt_new(NULL)) == NULL)
    	err(1, NULL);
    if (!lowdown_odt_rndr(out, rndr, n))
    	err(1, NULL);
    fwrite(out->data, 1, out->size, stdout);
    lowdown_odt_free(rndr);
    lowdown_buf_free(out);
    lowdown_node_free(n);
    lowdown_doc_free(doc);

SEE ALSO
lowdown(3), lowdown_odt_free(3), lowdown_odt_rndr(3)

STANDARDS
The referenced OpenDocument standard is 1.3: https://docs.oasis-open.org/office/OpenDocument/v1.3/.